function varargout = %optim_options_fmincon(algorithm)
    if argn(2) == 0
        varargout(1) = tlist(["optim_options_fmincon","contents"],[]);
        return
    end
    if or(algorithm == ["default","ipopt"])
        varargout(1) = struct(...
        "Algorithm", ["ipopt"],...
        "CheckGradients", %f,...
        "ConstraintTolerance",1e-6,...
        "Display", ['final','iter','notify','off','none'],...
        "FiniteDifferenceStepSize",%eps.^(1/3),...
        "FiniteDifferenceType",['central','forward','complexStep'],...
        "FunctionTolerance",1e-6,...
        "HessianApproximation",'lbfgs',...
        "HessianFcn",[],...
        "HonorBounds",%t,...
        "MaxFunctionEvaluations",3000,...
        "MaxIterations",1000,...
        "OptimalityTolerance",1e-6,...
        "OutputFcn",[],...
        "PlotFcn",[],...
        "SpecifyConstraintGradient",%f,...
        "SpecifyObjectiveGradient",%f,...
        "StepTolerance",1e-10,...
        "TypicalX",'ones(numberOfVariables,1)',...
        "InitBarrierParam", 0.1,...
        "BarrierParamUpdate",['monotone','adaptive'],...
        "HessPattern",sparse([]),...
        "ScaleProblem",%f);
        // hidden fields
        varargout(2) = [];
     else
        error("fmincon: ""%s"" is an unknown algorithm.\n")
     end
end
